#include "CommandLine.H"

#include <string.h>

#include "commands/CommandExit.H"
#include "commands/CommandHelp.H"

CommandLine::CommandLine() : _exit(false), count(0) {}

void CommandLine::Execute(int code) 
{
    CommandExit _cmdexit(this);
    CommandHelp _cmdhelp(this);

    switch(code)
    {
	case 0:
	    _cmdexit.Execute();
	    break;
	default:
	    _cmdhelp.Execute();
	    break;
    }
    if (!_exit) printf("prompt>");
}

void CommandLine::Message(char input)
{
    switch(input) 
    {
	case '\n':
	    _buffer[count] = '\0';
	    Parse();
	    break;
	case EOF:
	    _exit = true;
	    break;
	default:
	    _buffer[count++] = input;
	    break;
    }
}

void CommandLine::Parse() 
{
    int cmd = 1;
    
    if (strcmp(_buffer, "exit") == 0) {
      cmd = 0;
    }
    Execute(cmd);
    count = 0;
}
